optim.BM<-function(){
#normal mv function likelihood
	normalmv<-function(pars){
		
		#simulate data
		root.value<-pars[1]
		sigma.sq<-abs(pars[2])
		root.value.m <- matrix(c(rep(root.value,length(trait))),ncol=1)
		k<-length(trait)
		vcv <- vcv(tree)
		
		log.lik <- (-k/2)*(log(2*pi)) - 0.5*log(det(sigma.sq * vcv)) - 0.5*t(trait - root.value.m) %*% ginv(sigma.sq * vcv) %*% (trait - root.value.m)
				
		if(verbose.mode || debug.mode){
			cat('\nInfo : Params used : root.value:',root.value,', sigma.sq:',sigma.sq)
			
			cat('\nInfo : Log lik value : ',log.lik[1,1],'\n')
		}
		
		return(log.lik[1,1])
	}
	
	# load library
	library(ape)
	library(MASS)
	
	tree <<- read.nexus("datas/tree.nex")
	data <- read.csv("datas/traits.csv")
	trait <<- trait <<- data$seed_weigth[! is.na(data$seed_weigth)]
	trait <<-log(trait)
	
	lb <- 0.000000000001
	ub <- Inf
	res <- optim(c(1,1),normalmv,method="L-BFGS-B",lower=c(rep(lb,5)), upper=c(rep(ub,5)),control=list(fnscale=-1))

	return(res$value)
}