#
# Enable or disable a DEBUG mode for OU ( display every matrix, params, etc. )
# !!! and do only one call to log.lik, no optim !
#
# a verbose mode for OU (display optimized params during the optim process) 
#
# and a mode with our tests datas, easier to follow ( 4 species only )
#
debug.mode <<- F
test.data.mode <<- F
verbose.mode <<- F

# Set here your working directory that contains everything needed and comment the cat
cat("Don't forget to set the working directory in main.R \n")
setwd('')


# Load all bm and ou functions
source("bm_lhood.R",local=T)
source("ou_lhood.R",local=T)

# if debug mode is not enabled
if(! debug.mode){
	
# do the whole BM and OU process and display the results !!!
	
	BM.ll <- optim.BM()
	OU.ll <- optim.OU()
	
	cat("Optimized Log lik. Brownian Motion : ",BM.ll,"\n")
	cat("Optimized Log lik. Ornstein Uhlenbeck : ",OU.ll,"\n")
	cat("AIC Brownian Motion : ",BM.aic <- 2*2 - 2*BM.ll,"\n")
	cat("AIC Ornstein Uhlenbeck : ",OU.aic <- 2*5 - 2*OU.ll,"\n")
	cat("Difference (signifiant if > 3.4) : \n")
	cat("Well, it is ! ",abs(OU.aic - BM.aic),"\n\n")
	
# else do the debug mode process	
} else {
	cat('Debug mode ON : return only one non optimized likelihood','\n')
	cat("\nStep 8 : Log lik. value Ornstein Uhlenbeck, (not optimized) : "
			,OU.ll <- optim.OU(),"\n")
}