# here is the main code for the om model.
# it get all its function from the file om_lhood_lib.R

optim.OU <- function(){
	
	source("ou_lhood_lib.R",local=T)
	
	datas <- load.OU.datas('datas/tree.nex','datas/regimes.csv','datas/traits.csv')
	tree <- datas$tree
	
	regimes <- datas$regimes
	edges <- datas$edges
	x <- matrix(as.numeric(datas$traits[,3]),ncol=length(tree$tip.label))	
	x <- log(x)
	
	
# Declaration of of some usefull variable 
	regimes.nb <- length(regimes[1,] - 3)
	species.nb <- length(tree$tip.label)
	edge.nb <- length(tree$edge[,1])
	tree.length = vcv(tree)[1] 	
	
# Assign default values for the params we want to optim
			
	alpha <- 2.626011
	sigma.sq <- 0.8891499
	teta0 <- 2
	teta1 <- 0.8354484
	teta2 <- 4.145564
	
	   
	
#x,alpha,sigma,teta,tree,tree.length,species.nb,edges,regimes
	
	if(debug.mode){
		# return only one non optimized likelihood
		ret <- OU.log.likelihood(c(alpha,sigma.sq,teta0,teta1,teta2),edges=edges,regimes=regimes,
		tree=tree,x=x,regimes.nb=regimes.nb,species.nb=species.nb,edge.nb=edge.nb,
		tree.length=tree.length)
	}
	else{
		# counter, for diplay purpose only !
		counter <<- 0
		
		# do the optim
				
		ret <- optim(c(alpha,sigma.sq,teta0,teta1,teta2),edges=edges,regimes=regimes,
				tree=tree,x=x,regimes.nb=regimes.nb,species.nb=species.nb,edge.nb=edge.nb,
				tree.length=tree.length,fn=OU.log.likelihood,
				method="L-BFGS-B",lower=c(10^-7,10^-7,-Inf,-Inf,-Inf),
				upper=c(rep(Inf)),control=list(fnscale=-1),hessian = TRUE)
		
		cat('.\n')
		
		return(ret$value)	
	}
	
}	